@Echo Off
setlocal enabledelayedexpansion
Title Qompiler v0.80

If Not Exist tools\qbsp.exe GoTo NoTools
If Not Exist tools\vis.exe GoTo NoTools
If Not Exist tools\light.exe GoTo NoTools
If Not Exist *.MAP GoTo NeedMaps
If Not Exist Docs\Nul MD Docs
If Not Exist Qompiled\Nul MD Qompiled
If Not Exist Logs\Nul MD Logs
If Not Exist Configs\Nul MD Configs
If Exist "visdescription.bat" Move "visdescription.bat" "Docs"
If Exist "lightdescription.bat" Move "lightdescription.bat" "Docs"
If Exist "qbspdescription.bat" Move "qbspdescription.bat" "Docs"
If Exist "muk.bat" move "muk.bat" "Configs"
If "%1"=="DoIt" GoTo Qompile
If Not "%1"=="" GoTo NeedMaps
Echo Log file for Qompiler>Logs\QompilerLog.txt
Echo.>>Logs\QompilerLog.txt

:Start
Echo Lets Qompile some maps!
Echo.
Echo Do you want to load a config?
Echo.
Echo Making a config will let you use the same settings for your compiling tools 
Echo in the future, without having to reapply them each time you run Qompiler.
Echo.
Set /p _config=Type a config name to load or New to create a new config...
if /I %_config%==new goto NewConfig
 goto LoadConfig
 
:NewConfig
Echo.
Set /p _config=Type a name for this config...
If Not Exist configs\%_config%.bat Goto Tools
If Exist configs\%_config%.bat GoTo Overwrite

:Tools
If Exist %_qbsp%=="*" Echo Do you want to use QBSP?
If Exist %_qbsp%=="*" Set /p _qbsp="[Y]es or [N]o?"
Echo.
if /I %_qbsp%==Y set _qbsp=on
if /I %_qbsp%==N set _qbsp=off
If Not Exist *.BSP GoTo NeedBsp
Echo.
Echo Do you want to use VIS?
Set /p _vis="[Y]es or [N]o?"
if /I %_vis%==Y set _vis=on
if /I %_vis%==N set _vis=off
Echo.
Echo Do you want to use LIGHT?
Set /p _light="[Y]es or [N]o?"
if /I %_light%==Y set _light=on
if /I %_light%==N set _light=off
GoTo QBSP


:Overwrite
Echo.
Echo	The config %_config% already exists.
Echo.
Set /p _rename="[O]verwrite old config -or- [R]ename current?"
if /I %_rename%==O goto Tools
if /I %_rename%==R goto NewConfig
) else ( 
goto Overwrite

:LoadConfig
call Configs\%_config%.bat
Goto Run

:QBSP
if %_qbsp%==on Call docs\qbspdescription.bat
if %_qbsp%==off GoTo Vis
Set /p _qbspsettings=Input any desired qbsp settings, then press "Enter" to continue: 
Echo.

:VIS
if %_vis%==on Call docs\visdescription.bat
if %_vis%==off GoTo Light
Set /p _vissettings=Input any desired vis settings, then press "Enter" to continue: 
Echo.

:LIGHT
if %_light%==on Call docs\lightdescription.bat
If %_light%==off GoTo Run
Set /P _lightsettings=Input any desired light settings, then press "Enter" to continue: 
Echo.

:Run
Echo ::Generated by Qompiler v0.80>configs\%_config%.bat
Echo set _qbsp=%_qbsp%>>configs\%_config%.bat
Echo set _vis=%_vis%>>configs\%_config%.bat
Echo set _light=%_light%>>configs\%_config%.bat
Echo set _qbspsettings=%_qbspsettings%>>configs\%_config%.bat
Echo set _vissettings=%_vissettings%>>configs\%_config%.bat
Echo set _lightsettings=%_lightsettings%>>configs\%_config%.bat
Echo End of log.>>Logs\QompilerLog.txt
For %%i in (*.MAP) do call Qompiler DoIt %%i
Echo.

:Qompile
Echo Qompiling map %2...
Echo 
Echo Qompiling %2>>Logs\QompilerLog.txt
tools\qbsp.exe %_qbspsettings% %2>>Logs\QompilerLog.txt
tools\vis.exe %_vissettings% %2>>Logs\QompilerLog.txt
tools\light.exe %_lightsettings% %2>>Logs\QompilerLog.txt
Echo Finished map %2>>Logs\QompilerLog.txt
Echo.>>Logs\QompilerLog.txt
Echo.>>Logs\QompilerLog.txt
Echo.>>Logs\QompilerLog.txt
Echo %2>>Logs\Qompiled.txt
Move %2 Qompiled>Nul
If Exist "*.Prt" Del "*.Prt">Nul
If Exist "*.bsp" Move "*.bsp" Qompiled>Nul
If Exist "*.lit" Move "*.lit" Qompiled>Nul
If Exist "*.log" Move "*.log" Logs>Nul
Echo.
Echo Your maps have been Qompiled and put into the "Qompiled" folder.
Echo.
Echo Copy the contents of "Qompiled" and put them into your Quake Maps folder 
Echo or the Maps folder for whatever mod you are using.
GoTo End

:NeedMaps
Echo Qompiler and your maps must be in the same folder.  
Echo.
Echo Be sure your compiling tools are in the Tools directory, as well.
Echo.
Goto Restart

:NeedBsp
Echo You've selected not to use QBSP, but there are no BSP files available...
Echo.
Echo Put some .BSP files into the Qompiler folder and press enter...
Pause
GoTo Tools

:Restart
Echo Do you wish to restart? 
Echo.
Set /p op=Choose Y/N...
if /I %op%==Y goto Start
if /I %op%==N GoTo End

:NoTools
Echo Need qbsp.exe/vis.exe/light.exe in the Tools directory.
Goto Restart

:Retry
GoTo Qompile

:End
Pause

